/**
 * fts.c
 * Copyright (C) 2008 Markus Broeker
 *
 * file hierarchy browser
 */

#include <stdio.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/stat.h>

#include <fts.h>
#include <errno.h>

int compare (const FTSENT ** a, const FTSENT ** b)
{
    return 0;
}

int main (int argc, char **argv)
{
    FTS *fts;
    FTSENT *current = NULL;

    char **paths;

    int i;

    if (argc < 2) {
        printf ("Usage: %s [dir]...\n", argv[0]);
        return EXIT_FAILURE;
    }

    if ((paths = calloc (argc + 1, sizeof (char *))) == NULL) {
        perror ("CALLOC");
        return EXIT_FAILURE;
    }

    for (i = 1; i < argc; i++) {
        paths[i - 1] = argv[i];
    }

    paths[i] = NULL;
    errno = 0;

    if ((fts = fts_open (paths, FTS_NOSTAT, (void *)&compare)) == NULL) {
        perror ("fts_open");
        return EXIT_FAILURE;
    }

    while ((current = fts_read (fts)) != NULL) {
        if (!errno)
            printf ("%s/%s\n", current->fts_path, current->fts_name);
        else
            perror ("fts_read");
    }

    if (fts_close (fts) < 0)
        perror ("fts_close");

    if (paths != NULL)
        free (paths);

    return EXIT_SUCCESS;
}
